-- 恭喜获得新称号
Lua_GetTitleWindow = class("Lua_GetTitleWindow", Lua_Window);
function Lua_GetTitleWindow:ctor()
	self:superCall("ctor", self.list);

	self.windowName = "Lua_GetTitleWindow";
	self.skinName = "GetTitleWindow_skin";
	self.showClose = false;
	self.isClickClose = true;
end

function Lua_GetTitleWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.fightNum = Lua_NumberImage.new(self.content);
	self.fightNum.numWidth = 22;
	self.fightNum.prefix = "a_";
	self.fightNum.numAtlas = "number_atlas";
	self.fightNum.num = 9999;
	self.fightNum:setDepth(6);
	self.fightNum:setScale(0.8, 0.8);
	self.fightNum:setLocation(5, 148, 0);

	self.readBtn.clickScale = false;
	self.readBtn:addClickFuntion(self, self.onReadClick);

	-- self:addLuaEvent("CONVERSION_TITLEINFO",self,self.conversionTitle);
end

function Lua_GetTitleWindow:showWin(param)
	self:superCall("showWin", param);

	self.modelTexture = UIModelTexture();
	self.modelTexture:init(self.content, Vector2(0, 0), Vector2(1280, 720), 0, Vector3(0, 0, 0), Vector2(0, 2), 1);
	self.modelTexture:setCamView(8.15);
	self.modelTexture:setCamPos(-6000, 0, 0);
	self.modelTexture:setUrl("/effects/scsEffects/eu1_002", "eu1_002");

	local titleData = Lua_TitleData.new(param.label_id);
	self.fightNum.num = titleData.titleForce;
	if titleData.effect == nil then
		self.titleIcon:setEnable(true);
		self.titleIcon:setAltas(titleData.atlas, tostring(titleData.referenceId));
		self.titleIcon:resetSize();

		if self.titleEffect ~= nil then
			self.titleEffect:dispose();
			self.titleEffect = nil;
		end
	else
		self.titleIcon:setEnable(false);

		if self.titleEffect == nil then
			self.titleEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/" .. titleData.effect, titleData.effect, 0, -10);
		end
		self.titleEffect:setUrl("/effects/scsEffects/".. titleData.effect, titleData.effect);
		self.titleEffect:SetRenderQueue(self.fightLabIcon, 4, 2, false);
		if titleData.config.effect_size == nil then
			self.titleEffect:setSacle(250, 250, 250);
		else
			self.titleEffect:setSacle(titleData.config.effect_size[1], titleData.config.effect_size[2], titleData.config.effect_size[3]);
		end
	end
end

function Lua_GetTitleWindow:onReadClick()
	Lua_WindowUtil.openWin("Lua_TitleWindow", nil, self.showData.label_id);
	Lua_WindowUtil.openWin("Lua_GetTitleWindow", WinParam.ACTION_CLOSE);
end

function Lua_GetTitleWindow:dispose()
	if self.fightNum ~= nil then
		self.fightNum:dispose();
		self.fightNum = nil;
	end
	if self.modelTexture ~= nil then
		self.modelTexture:dispose();
		self.modelTexture = nil;
	end
	if self.titleEffect ~= nil then
		self.titleEffect:dispose();
		self.titleEffect = nil;
	end

	self:superCall("dispose");
end