checkRequire("Lua_TitleData");
checkRequire("Lua_MyPlayerModel");
Lua_TitleWindow = class("Lua_TitleWindow", Lua_Window);
function Lua_TitleWindow:ctor()
	self:superCall("ctor", self.list);

	self.windowName = "Lua_TitleWindow";
	self.skinName = "TitleWindow_skin";
	self.isModel = true;
	self.showBg = false;
	self.showClose = false;
end

function Lua_TitleWindow:buildShowItem()
	self:superCall("buildShowItem");

	-- 获取称号面板
	-- DataCenter.titleData:sAbandonMsg(label_id);
	-- 放弃当前称号
	-- DataCenter.titleData:sGainMsg(label_id);
	-- 获取单个当前称号
	-- DataCenter.titleData:sNewMsg(label_id);
	-- 查看新的称号

	self.model = Lua_MyPlayerModel.new(self.content, self.rightBg);
	self.model:setLocation(-35, -195, -200);

	self.titleDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 216, 544));
	self.titleDragList:setLocation(-458, -36, 0);
	self.titleDragList:setListCell(Lua_TitleItem, 106, 216, 1);

	self.desDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 258, 120));
	self.desDragList:setLocation(399, 122, 0);
	self.desDragList:setListCell(Lua_TitleDesItem, 35, 258, 1);

	self.adornBtn:addClickFuntion(self, self.onDdornClick);
	self.detailBtn:addClickFuntion(self, self.onDetailClick);

	self:addLuaEvent("TETLE_UPDATE", self, self.onTitleItemClick);
	self:addLuaEvent("SHOW_TITLEINFO", self, self.onShowInfo); -- 返回面板信息
	self:addLuaEvent("SELECT_TITLEINFO", self, self.onSelectInfo); -- 返回选择
	self:addLuaEvent("ABANDON_TITLEINFO", self, self.onAbandonInfo); -- 返回放弃
	self:addLuaEvent("UPDATEONE_TITLEINFO", self, self.onUpdataOneInfo); -- 返回单个信息
	self:addLuaEvent("USE_TITLEINFO", self, self.onUseInfo);
	--self:addLuaEvent("CONVERSION_TITLEINFO", self, self.onConversionInfo);

	DataCenter.titleData:sInitMsg();
end

function Lua_TitleWindow:showWin(param)
	self.param = param;
end

function Lua_TitleWindow:onTitleItemClick(tid)
	local arr = self.titleDragList.showList;
	local len = arr:getSize();
	for i = 1, len do
		if tid == arr[i].data.id then
			arr[i]:setSelected(true);
			self:callUpdataFun(arr[i].data);
		else
			arr[i]:setSelected(false);
		end
	end
	DataCenter.roleData.curSelected = tid;
end

function Lua_TitleWindow:callUpdataFun(vo)
	self.data = vo;

	if vo.id == DataCenter.titleData.cur_label_id then
		self.adornBtn.label = LanUtil.getValue(110460); -- 卸下
	else
		self.adornBtn.label = LanUtil.getValue(110459); -- 佩戴
	end

	local data = Lua_TitleData.new(self.data.id);
	local desArr = Array();
	for i = 1, data.desc:getSize() do
		desArr:add({wordsStr = "[85A8BE]"..data.desc[i].wordsStr.."：[-]", numStr = data.desc[i].numStr});
	end
	self.desDragList:setLuaArrayData(desArr, false);

	self.desLab1.text = data.name;
	self.tipsLabel.text = data.outputs;  
	self.leftTime = data.time;

	if self.data.isActive == true then
		DataCenter.titleData:sGainMsg(self.data.id)
		if data.limit_type == 0 then
			self.renTxt.text = LanUtil.getValue(110450); 
		elseif data.limit_type == 1 then
			self.renTxt.text = LanUtil.formateStr(LanUtil.getValue(110463), tostring(TimeTransform.getInstance():transSeconds1(self.leftTime, true)));
		else -- vip
			self.renTxt.text = data.limit_str;
		end
	else
		self.renTxt.text = data.compareTitle; 
	end
	self.adornBtn:setEnable(self.data.isActive);

	local tdata = Lua_TitleData.new(data.id)
	if tdata.effect == nil then
		self.showTitleIcon:setAltas("item7", tostring(self.data.referenceId));
		self.showTitleIcon:resetSize();
		if self.rsEffect ~= nil then
			self.rsEffect:dispose();
			self.rsEffect = nil;
		end
	else
		if self.rsEffect == nil then
			self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..tdata.effect, tdata.effect, 0, 0);
		end
		self.rsEffect:setUrl("/effects/scsEffects/"..tdata.effect, tdata.effect);
		self.rsEffect:SetRenderQueue(self.renTxt, 4, 2, false);
		if tdata.config.effect_size == nil then
			self.rsEffect:setSacle(250, 250, 250);
		else
			self.rsEffect:setSacle(tdata.config.effect_size[1], tdata.config.effect_size[2], tdata.config.effect_size[3]);
		end
		self.rsEffect:setLocation(-30, 190, 0);
	end
	self.showTitleIcon:setEnable(tdata.effect == nil);
end

function Lua_TitleWindow:onShowInfo()
	self.alltitleList = DataCenter.titleData.alltitleList;
	local len = DataCenter.titleData.alltitleList:getSize();
	for i = 1, len do
		if DataCenter.titleData.cur_label_id ~= 0 then
			DataCenter.roleData.curSelected = DataCenter.titleData.cur_label_id
		else
			if DataCenter.titleData.alltitleList[i].isActive == true then
				DataCenter.roleData.curSelected = DataCenter.titleData.alltitleList[i].id
			else
				DataCenter.roleData.curSelected = DataCenter.titleData.alltitleList[1].id
			end
		end
	end

	if self.param ~= nil then 
		DataCenter.roleData.curSelected = self.param;
		self.param = nil;
	end
	self:setSelectedTitle(DataCenter.roleData.curSelected);
	self.titleDragList:setLuaArrayData(DataCenter.titleData.alltitleList, false);
end

function Lua_TitleWindow:setSelectedTitle(tid)
	self.curSelected = tid;
	local len = DataCenter.titleData.alltitleList:getSize();
	for i = 1, len do
		if DataCenter.titleData.alltitleList[i].id == tid then
			DataCenter.titleData.alltitleList[i].selected = true;
			self:callUpdataFun(DataCenter.titleData.alltitleList[i]);
			self.index = i;
		else
			DataCenter.titleData.alltitleList[i].selected = false;
		end	
	end
	self.titleDragList:setLuaArrayData(DataCenter.titleData.alltitleList, false);

	if self.index ~= nil then
		self.titleDragList:moveToIndex(self.index, true);
	end
end

function Lua_TitleWindow:onSelectInfo()
	self:setSelectedTitle(DataCenter.titleData.cur_label_id);
end

function Lua_TitleWindow:onAbandonInfo()
	if self.curSelected == nil then
		return;
	end
	self:setSelectedTitle(self.curSelected);
end

-- 单个信息
function Lua_TitleWindow:onUpdataOneInfo()
	if self.data.timeLimit ~= -1 then
		self.leftTime = self.data.timeLimit;
		Lua_CommonUtil.addTimer("CountDown", 1, self, self.onCountDown);
		self:onCountDown();
	else  -- self.data.timeLimit ~= -2 then
		Lua_CommonUtil.removeTimer(self, self.onCountDown);
	end 
end

-- 倒计时
function Lua_TitleWindow:onCountDown()
	if self.leftTime > 0 then
		self.leftTime = self.leftTime-1;
		self.renTxt.text = LanUtil.formateStr(LanUtil.getValue(110461), tostring(TimeTransform.getInstance():transSeconds1(self.leftTime, true)));
	else
		Lua_CommonUtil.removeTimer(self,self.onCountDown);
		self.renTxt.text = LanUtil.getValue(110451);
	end
end

function Lua_TitleWindow:onDdornClick(go)
	if self.data.isActive == true then
		if DataCenter.titleData.cur_label_id == self.data.id then
			DataCenter.titleData:sAbandonMsg(self.data.id); -- 放弃佩戴
		else
			DataCenter.titleData:sSelectMsg(self.data.id); -- 选中佩戴
		end
	end
end

-- c称号总属性
function Lua_TitleWindow:onDetailClick(go)
	Lua_WindowUtil.openWin("Lua_TitleTipsWindow");
end

function Lua_TitleWindow:dispose()
	if self.playerModel ~= nil then
		self.playerModel:dispose();
	end
	if DataCenter.titleData.cur_label_id ~= nil then
		DataCenter.titleData.cur_label_id = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onCountDown); 

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TitleItem = class("Lua_TitleItem", Lua_ListCell);
function Lua_TitleItem:ctor(p)
	self:superCall("ctor", p, "TitleItem_skin");
end

function Lua_TitleItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
	
	local tdata = Lua_TitleData.new(data.id)
	if tdata.effect == nil then
		self.showTitleIcon:setAltas("item7", tostring(self.data.referenceId));
		self.showTitleIcon:resetSize();

		if self.rsEffect ~= nil then
			self.rsEffect:dispose();
			self.rsEffect = nil;
		end
	else
		if self.rsEffect == nil then
			self.rsEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/"..tdata.effect, tdata.effect, 0, 0);
			self.rsEffect:setGrayShader("Transparent_Gray", "Particle_Gray2");
			self.rsEffect:SetRenderQueue(self.itemBg, 4, 2, false);
		end
		self.rsEffect:setUrl("/effects/scsEffects/"..tdata.effect, tdata.effect);

		if tdata.config.list_effect_size ~= nil then
			self.rsEffect:setSacle(tdata.config.list_effect_size[1], tdata.config.list_effect_size[2], tdata.config.list_effect_size[3]);
		else
			self.rsEffect:setSacle(250, 250, 250);
		end
	end
	self.showTitleIcon:setEnable(tdata.effect == nil);

	if self.data.isActive == true then
		self.showTitleIcon.color = Color.New(1, 1, 1, 1);
		if self.rsEffect ~= nil then
			self.rsEffect:setGray(false);
		end
	else
		self.showTitleIcon.color = Color.New(0, 1, 1, 1);
		if self.rsEffect ~= nil then
			self.rsEffect:setGray(true);
		end
	end

	self.bselected = DataCenter.roleData.curSelected == self.data.id;
	if self.bselected == true then
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_d2");
	else
		self.itemBg:setAltas("common_atlas_1", "ui_common_widget_d1");
	end
	self.selectIcon:setEnable(self.bselected);
	self.tipsObj:SetActive(self.data.id == DataCenter.titleData.cur_label_id);
end

function Lua_TitleItem:onPlayerSoundClick(go)
	Lua_MsgUtil.callFunc("TETLE_UPDATE", self.data.id);
end

function Lua_TitleItem:checkOutBound(showRect)
	if self.data == nil then
		return;
	end

	if self.rsEffect ~= nil then
		local width = self.rsEffect.width;
		local height = self.rsEffect.height;
		local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
		self.rsEffect:setEnable(showRect:containeRect(rect));
	end
end

function Lua_TitleItem:setSelected(val)
	if self.bselected ~= val then
		self.bselected = val;
		if self.bselected == true then
			self.itemBg:setAltas("common_atlas_1", "ui_common_widget_d2");
		else
			self.itemBg:setAltas("common_atlas_1", "ui_common_widget_d1");
		end
		self.selectIcon:setEnable(self.bselected);
	end
end

function Lua_TitleItem:dispose()
	self.data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_TitleDesItem = class("Lua_TitleDesItem", Lua_ListCell);
function Lua_TitleDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_TitleDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desLab = Lua_ShowItem.new(self.content);
	self.desLab.isWords = true;
	self.desLab.isNum = true;
	self.desLab.wordsFontSize = 22;
	self.desLab.numFontSize = 22;
	self.desLab:setLocation(-129, 6.5, 0);
end

function Lua_TitleDesItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.desLab:setData({wordsStr = data.wordsStr, numStr = data.numStr});
end

function Lua_TitleDesItem:dispose()
	if self.desLab ~= nil then
		self.desLab:dispose();
		self.desLab = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end